Index: src/UIElements/Dialog.cpp
===================================================================
--- src/UIElements/Dialog.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/UIElements/Dialog.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -51,6 +51,7 @@
 
 // Base class
-Dialog::Query::Query(string _title) :
-    title(_title)
+Dialog::Query::Query(string _title, string _description) :
+    title(_title),
+    description(_description)
 {}
 
@@ -61,8 +62,22 @@
 }
 
+const std::string Dialog::Query::getDescription() const{
+  return description;
+}
+// empty Queries
+
+Dialog::EmptyQuery::EmptyQuery(string title, std::string description) :
+    Query(title, description)
+{}
+
+Dialog::EmptyQuery::~EmptyQuery() {}
+
+void Dialog::EmptyQuery::setResult() {
+}
+
 // Int Queries
 
-Dialog::IntQuery::IntQuery(string title,int *_target) :
-    Query(title), target(_target)
+Dialog::IntQuery::IntQuery(string title,int *_target, std::string description) :
+    Query(title, description), target(_target)
 {}
 
@@ -75,6 +90,6 @@
 // String Queries
 
-Dialog::StringQuery::StringQuery(string title,string *_target) :
-    Query(title), target(_target)
+Dialog::StringQuery::StringQuery(string title,string *_target, std::string _description) :
+    Query(title, _description), target(_target)
 {}
 
@@ -87,6 +102,6 @@
 // Double Queries
 
-Dialog::DoubleQuery::DoubleQuery(string title,double *_target) :
-    Query(title), target(_target)
+Dialog::DoubleQuery::DoubleQuery(string title,double *_target, std::string _description) :
+    Query(title, _description), target(_target)
 {}
 
@@ -100,9 +115,10 @@
 // Molecule Queries
 
-Dialog::MoleculeQuery::MoleculeQuery(string title, molecule **_target, MoleculeListClass *_molecules) :
-    Query(title),
-    target(_target),
+Dialog::MoleculeQuery::MoleculeQuery(string title, molecule **_target, MoleculeListClass *_molecules, std::string _description) :
+    Query(title, _description),
+    tmp(0),
     molecules(_molecules),
-    tmp(0)
+    target(_target)
+
 {}
 
@@ -115,6 +131,9 @@
 // Vector Queries
 
-Dialog::VectorQuery::VectorQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check) :
-  Query(title), target(_target), cellSize(_cellSize), check(_check)
+Dialog::VectorQuery::VectorQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check, std::string _description) :
+  Query(title, _description),
+  cellSize(_cellSize),
+  check(_check),
+  target(_target)
 {
 tmp = new Vector();
@@ -129,2 +148,15 @@
   *target = *tmp;
 }
+
+// Element Queries
+Dialog::ElementQuery::ElementQuery(std::string title, const element **_target, std::string _description) :
+  Query(title, _description),
+  tmp(0),
+  target(_target)
+  {}
+
+Dialog::ElementQuery::~ElementQuery(){}
+
+void Dialog::ElementQuery::setResult(){
+  *target=tmp;
+}
Index: src/UIElements/Dialog.hpp
===================================================================
--- src/UIElements/Dialog.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/UIElements/Dialog.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -15,4 +15,5 @@
 class molecule;
 class Vector;
+class element;
 
 class Dialog
@@ -22,9 +23,11 @@
   virtual ~Dialog();
 
-  virtual void queryInt(const char *, int *)=0;
-  virtual void queryDouble(const char*,double *)=0;
-  virtual void queryString(const char*, std::string *)=0;
-  virtual void queryMolecule(const char*,molecule**,MoleculeListClass*)=0;
-  virtual void queryVector(const char*,Vector *,const double *const,bool)=0;
+  virtual void queryEmpty(const char *, std::string = "")=0;
+  virtual void queryInt(const char *, int *, std::string = "")=0;
+  virtual void queryDouble(const char*,double *, std::string = "")=0;
+  virtual void queryString(const char*, std::string *, std::string = "")=0;
+  virtual void queryMolecule(const char*,molecule**,MoleculeListClass*, std::string = "")=0;
+  virtual void queryVector(const char*,Vector *,const double *const,bool, std::string = "")=0;
+  virtual void queryElement(const char*,const element **, std::string = "")=0;
 
   virtual bool display();
@@ -44,12 +47,23 @@
   class Query {
   public:
-    Query(std::string _title);
-    ~Query();
+    Query(std::string _title, std::string _description = "");
+    virtual ~Query();
     virtual bool handle()=0;
     virtual void setResult()=0;
   protected:
     const std::string getTitle() const;
+    const std::string getDescription() const;
   private:
-    std::string title;
+    std::string title;  //!< short title of the query
+    std::string description; //!< longer description for tooltips or for help
+  };
+
+  // Empty Query is just meant for showing text, such as version, help, initial message or alike
+  class EmptyQuery : public Query {
+  public:
+    EmptyQuery(std::string title, std::string _description = "");
+    virtual ~EmptyQuery();
+    virtual bool handle()=0;
+    virtual void setResult();
   };
 
@@ -57,6 +71,6 @@
   class IntQuery : public Query {
   public:
-    IntQuery(std::string title,int *_target);
-    ~IntQuery();
+    IntQuery(std::string title,int *_target, std::string _description = "");
+    virtual ~IntQuery();
     virtual bool handle()=0;
     virtual void setResult();
@@ -69,6 +83,6 @@
   class DoubleQuery : public Query {
   public:
-    DoubleQuery(std::string title,double *_target);
-    ~DoubleQuery();
+    DoubleQuery(std::string title,double *_target, std::string _description = "");
+    virtual ~DoubleQuery();
     virtual bool handle()=0;
     virtual void setResult();
@@ -81,6 +95,6 @@
   class StringQuery : public Query {
   public:
-    StringQuery(std::string title,std::string *_target);
-    ~StringQuery();
+    StringQuery(std::string title,std::string *_target, std::string _description = "");
+    virtual ~StringQuery();
     virtual bool handle()=0;
     virtual void setResult();
@@ -94,6 +108,6 @@
   class MoleculeQuery : public Query {
   public:
-    MoleculeQuery(std::string title, molecule **_target, MoleculeListClass *_molecules);
-    ~MoleculeQuery();
+    MoleculeQuery(std::string title, molecule **_target, MoleculeListClass *_molecules, std::string _description = "");
+    virtual ~MoleculeQuery();
     virtual bool handle()=0;
     virtual void setResult();
@@ -107,6 +121,6 @@
   class VectorQuery : public Query {
   public:
-      VectorQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check);
-      ~VectorQuery();
+      VectorQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check, std::string _description = "");
+      virtual ~VectorQuery();
       virtual bool handle()=0;
       virtual void setResult();
@@ -119,4 +133,16 @@
   };
 
+  class ElementQuery : public Query {
+  public:
+    ElementQuery(std::string title, const element**_target, std::string _description = "");
+    virtual ~ElementQuery();
+    virtual bool handle()=0;
+    virtual void setResult();
+  protected:
+    const element *tmp;
+  private:
+    const element **target;
+  };
+
 void registerQuery(Query* query);
 
@@ -126,3 +152,4 @@
 };
 
+
 #endif /* DIALOG_HPP_ */
Index: src/UIElements/MainWindow.hpp
===================================================================
--- src/UIElements/MainWindow.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/UIElements/MainWindow.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -25,9 +25,4 @@
 };
 
-typedef void (*MenuMaker)(Menu*,MoleculeListClass*, config*, periodentafel*);
-
-struct menuPopulaters{
-  MenuMaker MakeEditMoleculesMenu;
-};
 
 #endif /* MAINWINDOW_HPP_ */
Index: src/UIElements/TextDialog.cpp
===================================================================
--- src/UIElements/TextDialog.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/UIElements/TextDialog.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -10,4 +10,6 @@
 #include "UIElements/TextDialog.hpp"
 
+#include "World.hpp"
+#include "periodentafel.hpp"
 #include "atom.hpp"
 #include "molecule.hpp"
@@ -27,28 +29,47 @@
 
 
-void TextDialog::queryInt(const char* title, int* target){
-  registerQuery(new IntTextQuery(title,target));
-}
-
-void TextDialog::queryDouble(const char* title, double* target){
-  registerQuery(new DoubleTextQuery(title,target));
-}
-
-void TextDialog::queryString(const char* title, string* target){
-  registerQuery(new StringTextQuery(title,target));
-}
-
-void TextDialog::queryMolecule(const char* title, molecule **target, MoleculeListClass *molecules) {
-  registerQuery(new MoleculeTextQuery(title,target,molecules));
-}
-
-void TextDialog::queryVector(const char* title, Vector *target,const double *const cellSize, bool check) {
-  registerQuery(new VectorTextQuery(title,target,cellSize,check));
+void TextDialog::queryEmpty(const char* title, string description){
+  registerQuery(new EmptyTextQuery(title,description));
+}
+
+void TextDialog::queryInt(const char* title, int* target, string description){
+  registerQuery(new IntTextQuery(title,target,description));
+}
+
+void TextDialog::queryDouble(const char* title, double* target, string description){
+  registerQuery(new DoubleTextQuery(title,target,description));
+}
+
+void TextDialog::queryString(const char* title, string* target, string description){
+  registerQuery(new StringTextQuery(title,target,description));
+}
+
+void TextDialog::queryMolecule(const char* title, molecule **target, MoleculeListClass *molecules, string description) {
+  registerQuery(new MoleculeTextQuery(title,target,molecules,description));
+}
+
+void TextDialog::queryVector(const char* title, Vector *target,const double *const cellSize, bool check, string description) {
+  registerQuery(new VectorTextQuery(title,target,cellSize,check,description));
+}
+
+void TextDialog::queryElement(const char* title, const element **target, string description){
+  registerQuery(new ElementTextQuery(title,target,description));
 }
 
 /************************** Query Infrastructure ************************/
 
-TextDialog::IntTextQuery::IntTextQuery(string title,int *_target) :
-    Dialog::IntQuery(title,_target)
+TextDialog::EmptyTextQuery::EmptyTextQuery(string title, std::string _description) :
+    Dialog::EmptyQuery(title,_description)
+{}
+
+TextDialog::EmptyTextQuery::~EmptyTextQuery() {}
+
+bool TextDialog::EmptyTextQuery::handle() {
+  cout << "Message of " << getTitle() << ":\n" << getDescription() << "\n";
+  return true;
+}
+
+TextDialog::IntTextQuery::IntTextQuery(string title, int * _target, std::string _description) :
+    Dialog::IntQuery(title,_target,_description)
 {}
 
@@ -56,11 +77,23 @@
 
 bool TextDialog::IntTextQuery::handle() {
-  Log() << Verbose(0) << getTitle();
-  cin >> tmp;
-  return true;
-}
-
-TextDialog::StringTextQuery::StringTextQuery(string title,string *_target) :
-    Dialog::StringQuery(title,_target)
+  bool badInput = false;
+  do{
+    badInput = false;
+    Log() << Verbose(0) << getTitle();
+    cin >> tmp;
+    if(cin.fail()){
+      badInput=true;
+      cin.clear();
+      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+      Log() << Verbose(0) << "Input was not a number!" << endl;
+    }
+  } while(badInput);
+  // clear the input buffer of anything still in the line
+  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+  return true;
+}
+
+TextDialog::StringTextQuery::StringTextQuery(string title,string *_target, std::string _description) :
+    Dialog::StringQuery(title,_target,_description)
 {}
 
@@ -69,10 +102,10 @@
 bool TextDialog::StringTextQuery::handle() {
   Log() << Verbose(0) << getTitle();
-  cin >> tmp;
-  return true;
-}
-
-TextDialog::DoubleTextQuery::DoubleTextQuery(string title,double *_target) :
-    Dialog::DoubleQuery(title,_target)
+  getline(cin,tmp);
+  return true;
+}
+
+TextDialog::DoubleTextQuery::DoubleTextQuery(string title,double *_target, std::string _description) :
+    Dialog::DoubleQuery(title,_target,_description)
 {}
 
@@ -80,37 +113,135 @@
 
 bool TextDialog::DoubleTextQuery::handle() {
+  bool badInput = false;
+  do{
+    badInput = false;
+    Log() << Verbose(0) << getTitle();
+    cin >> tmp;
+    if(cin.fail()){
+      badInput = true;
+      cin.clear();
+      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+      Log() << Verbose(0) << "Input was not a number!" << endl;
+    }
+  }while(badInput);
+  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+  return true;
+}
+
+TextDialog::MoleculeTextQuery::MoleculeTextQuery(string title, molecule **_target, MoleculeListClass *_molecules, std::string _description) :
+    Dialog::MoleculeQuery(title,_target,_molecules,_description)
+{}
+
+TextDialog::MoleculeTextQuery::~MoleculeTextQuery() {}
+
+bool TextDialog::MoleculeTextQuery::handle() {
+  int idxOfMol=0;
+  bool badInput = false;
+  do{
+    badInput = false;
+    Log() << Verbose(0) << getTitle();
+    cin >> idxOfMol;
+    if(cin.fail()){
+      badInput = true;
+      cin.clear();
+      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+      Log() << Verbose(0) << "Input was not a number!" << endl;
+      continue;
+    }
+
+    tmp = molecules->ReturnIndex(idxOfMol);
+    if(!tmp && idxOfMol!=-1){
+      Log() << Verbose(0) << "Invalid Molecule Index" << endl;
+      badInput = true;
+    }
+
+  } while(badInput);
+  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+  return (idxOfMol!=-1);
+}
+
+TextDialog::VectorTextQuery::VectorTextQuery(std::string title, Vector *_target, const double *const _cellSize, bool _check, std::string _description) :
+    Dialog::VectorQuery(title,_target,_cellSize,_check,_description)
+{}
+
+TextDialog::VectorTextQuery::~VectorTextQuery()
+{}
+
+bool TextDialog::VectorTextQuery::handle() {
   Log() << Verbose(0) << getTitle();
-  cin >> tmp;
-  return true;
-}
-
-TextDialog::MoleculeTextQuery::MoleculeTextQuery(string title, molecule **_target, MoleculeListClass *_molecules) :
-    Dialog::MoleculeQuery(title,_target,_molecules)
-{}
-
-TextDialog::MoleculeTextQuery::~MoleculeTextQuery() {}
-
-bool TextDialog::MoleculeTextQuery::handle() {
-  int idxOfMol;
-  Log() << Verbose(0) << getTitle();
-  cin >> idxOfMol;
-  tmp = molecules->ReturnIndex(idxOfMol);
-  while(!tmp && (idxOfMol !=-1)) {
-    Log() << Verbose(0) << "Invalid Molecule Index" << endl;
-    Log() << Verbose(0) << getTitle();
-    cin >> idxOfMol;
-    tmp = molecules->ReturnIndex(idxOfMol);
+
+  char coords[3] = {'x','y','z'};
+  int j = -1;
+  for (int i=0;i<3;i++) {
+    j += i+1;
+    do {
+      Log() << Verbose(0) << coords[i] << "[0.." << cellSize[j] << "]: ";
+      cin >> (*tmp)[i];
+    } while ((((*tmp)[i] < 0) || ((*tmp)[i] >= cellSize[j])) && (check));
   }
-  return (idxOfMol!=-1);
-}
-
-TextDialog::VectorTextQuery::VectorTextQuery(std::string title, Vector *_target, const double *const _cellSize, bool _check) :
-    Dialog::VectorQuery(title,_target,_cellSize,_check)
-{}
-
-TextDialog::VectorTextQuery::~VectorTextQuery()
-{}
-
-bool TextDialog::VectorTextQuery::handle() {
- tmp->AskPosition(cellSize,check);
-}
+  return true;
+}
+
+
+TextDialog::ElementTextQuery::ElementTextQuery(std::string title, const element **target, std::string _description) :
+    Dialog::ElementQuery(title,target,_description)
+{}
+
+TextDialog::ElementTextQuery::~ElementTextQuery()
+{}
+
+bool TextDialog::ElementTextQuery::handle() {
+  bool badInput=false;
+  bool aborted = false;
+  do{
+    badInput = false;
+    Log() << Verbose(0) << getTitle();
+
+    // try to read as Atomic number
+    int Z;
+    cin >> Z;
+    if(!cin.fail()){
+      if(Z==-1){
+        aborted = true;
+      }
+      else{
+        tmp = World::getInstance().getPeriode()->FindElement(Z);
+        if(!tmp){
+          Log() << Verbose(0) << "No element with this atomic number!" << endl;
+          badInput = true;
+        }
+      }
+      continue;
+    }
+    else{
+      cin.clear();
+    }
+
+    // Try to read as shorthand
+    // the last buffer content was not removed, so we read the
+    // same thing again, this time as a string
+    string shorthand;
+    cin >> shorthand;
+    if(!cin.fail()){
+      if(shorthand.empty()){
+        aborted = true;
+      }
+      else{
+        tmp = World::getInstance().getPeriode()->FindElement(shorthand.c_str());
+        if(!tmp){
+          Log() << Verbose(0) << "No element with this shorthand!" << endl;
+          badInput = true;
+        }
+      }
+    }
+    else{
+      Log() << Verbose(0) << "Could not read input. Try Again." << endl;
+      cin.clear();
+      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+      badInput = true;
+    }
+
+  }while(badInput);
+  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+  return !aborted;
+}
Index: src/UIElements/TextDialog.hpp
===================================================================
--- src/UIElements/TextDialog.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/UIElements/TextDialog.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -19,16 +19,25 @@
   virtual ~TextDialog();
 
-  virtual void queryInt(const char *, int *);
-  virtual void queryString(const char*, std::string *);
-  virtual void queryDouble(const char*, double*);
-  virtual void queryMolecule(const char*,molecule**,MoleculeListClass*);
-  virtual void queryVector(const char*,Vector *,const double * const,bool);
+  virtual void queryEmpty(const char *, std::string = "");
+  virtual void queryInt(const char *, int *, std::string = "");
+  virtual void queryString(const char*, std::string *, std::string = "");
+  virtual void queryDouble(const char*, double*, std::string = "");
+  virtual void queryMolecule(const char*,molecule**,MoleculeListClass*, std::string = "");
+  virtual void queryVector(const char*,Vector *,const double * const,bool, std::string = "");
+  virtual void queryElement(const char*,const element **, std::string = "");
 
 protected:
   // specialized stuff for text queries
+  class EmptyTextQuery : public Dialog::EmptyQuery {
+  public:
+    EmptyTextQuery(std::string title, std::string _description = NULL);
+    virtual ~EmptyTextQuery();
+    virtual bool handle();
+  };
+
   class IntTextQuery : public Dialog::IntQuery {
   public:
-    IntTextQuery(std::string title, int *_target);
-    ~IntTextQuery();
+    IntTextQuery(std::string title, int *_target, std::string _description = NULL);
+    virtual ~IntTextQuery();
     virtual bool handle();
   };
@@ -36,6 +45,6 @@
   class DoubleTextQuery : public Dialog::DoubleQuery {
   public:
-    DoubleTextQuery(std::string title, double *_target);
-    ~DoubleTextQuery();
+    DoubleTextQuery(std::string title, double *_target, std::string _description = NULL);
+    virtual ~DoubleTextQuery();
     virtual bool handle();
   };
@@ -43,6 +52,6 @@
   class StringTextQuery : public Dialog::StringQuery {
   public:
-    StringTextQuery(std::string title, std::string *_target);
-    ~StringTextQuery();
+    StringTextQuery(std::string title, std::string *_target, std::string _description = NULL);
+    virtual ~StringTextQuery();
     virtual bool handle();
   };
@@ -50,6 +59,6 @@
   class MoleculeTextQuery : public Dialog::MoleculeQuery {
   public:
-    MoleculeTextQuery(std::string title, molecule **_target, MoleculeListClass *_molecules);
-    ~MoleculeTextQuery();
+    MoleculeTextQuery(std::string title, molecule **_target, MoleculeListClass *_molecules, std::string _description = NULL);
+    virtual ~MoleculeTextQuery();
     virtual bool handle();
   };
@@ -57,6 +66,13 @@
   class VectorTextQuery : public Dialog::VectorQuery {
   public:
-    VectorTextQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check);
-    ~VectorTextQuery();
+    VectorTextQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check, std::string _description = NULL);
+    virtual ~VectorTextQuery();
+    virtual bool handle();
+  };
+
+  class ElementTextQuery : public Dialog::ElementQuery {
+  public:
+    ElementTextQuery(std::string title, const element **_target, std::string _description = NULL);
+    virtual ~ElementTextQuery();
     virtual bool handle();
   };
Index: src/UIElements/TextStatusIndicator.cpp
===================================================================
--- src/UIElements/TextStatusIndicator.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/UIElements/TextStatusIndicator.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -27,5 +27,5 @@
   Process *proc;
   // we are only observing Processes
-  if(proc=dynamic_cast<Process*>(subject)){
+  if((proc=dynamic_cast<Process*>(subject))){
     // see what kind of progress we have to display
     if(proc->getMaxSteps()>0){
Index: src/UIElements/TextUIFactory.cpp
===================================================================
--- src/UIElements/TextUIFactory.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/UIElements/TextUIFactory.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -27,6 +27,6 @@
 }
 
-MainWindow* TextUIFactory::makeMainWindow(menuPopulaters populaters,MoleculeListClass *molecules, config *configuration, periodentafel *periode, char *ConfigFileName) {
-  return new TextWindow(populaters,molecules,configuration,periode,ConfigFileName);
+MainWindow* TextUIFactory::makeMainWindow() {
+  return new TextWindow();
 }
 
Index: src/UIElements/TextUIFactory.hpp
===================================================================
--- src/UIElements/TextUIFactory.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/UIElements/TextUIFactory.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -19,5 +19,5 @@
 
   virtual Dialog* makeDialog();
-  virtual MainWindow* makeMainWindow(menuPopulaters,MoleculeListClass *, config *, periodentafel *, char *);
+  virtual MainWindow* makeMainWindow();
 
 protected:
Index: src/UIElements/TextWindow.cpp
===================================================================
--- src/UIElements/TextWindow.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/UIElements/TextWindow.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -27,4 +27,5 @@
 #include "molecule.hpp"
 #include "periodentafel.hpp"
+#include "World.hpp"
 
 #include "Legacy/oldmenu.hpp"
@@ -38,5 +39,7 @@
 #include "UIElements/TextStatusIndicator.hpp"
 #include "Actions/MethodAction.hpp"
+#include "Actions/MoleculeAction/ChangeNameAction.hpp"
 #include "Actions/ErrorAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "Views/StreamStringView.hpp"
 #include "Views/MethodStringView.hpp"
@@ -47,6 +50,10 @@
 
 // TODO: see what code can be moved to a base class for Graphic and Text Windows
-TextWindow::TextWindow(menuPopulaters populaters,MoleculeListClass *molecules, config *configuration, periodentafel *periode, char *ConfigFileName)
+TextWindow::TextWindow()
 {
+  MoleculeListClass *molecules = World::getInstance().getMolecules();
+  config *configuration = World::getInstance().getConfig();
+  periodentafel *periode = World::getInstance().getPeriode();
+  char *ConfigFileName = NULL;
   old_menu = new oldmenu;
 
@@ -56,4 +63,12 @@
   moleculeView = new StreamStringView(boost::bind(&MoleculeListClass::Enumerate,molecules,_1));
   new DisplayMenuItem(main_menu,moleculeView,"Molecule List");
+
+  new SeperatorItem(main_menu);
+
+  Action* undoAction = ActionRegistry::getInstance().getActionByName("Undo");
+  new ActionMenuItem('u',"Undo last operation",main_menu,undoAction);
+
+  Action* redoAction = ActionRegistry::getInstance().getActionByName("Redo");
+  new ActionMenuItem('r',"Redo last operation",main_menu,redoAction);
 
   new SeperatorItem(main_menu);
@@ -92,7 +107,7 @@
   // call all functions used to build the submenus
 
-  populaters.MakeEditMoleculesMenu(editMoleculesMenu,molecules,configuration,periode);
+  populateEditMoleculesMenu(editMoleculesMenu);
 
-  returnFromEditMoleculeAction = new MethodAction("returnAction",boost::bind(&TextMenu::doQuit,editMoleculesMenu),false);
+  Action *returnFromEditMoleculeAction = new TextMenu::LeaveAction(editMoleculesMenu);
   MenuItem *returnItem = new ActionMenuItem('q',"return to Main menu",editMoleculesMenu,returnFromEditMoleculeAction);
 
@@ -108,5 +123,4 @@
   delete old_menu;
   delete quitAction;
-  delete returnFromEditMoleculeAction;
   delete moleculeView;
   delete statusIndicator;
@@ -117,2 +131,28 @@
   main_menu->display();
 }
+
+void TextWindow::populateEditMoleculesMenu(Menu* editMoleculesMenu)
+{
+  MoleculeListClass *molecules = World::getInstance().getMolecules();
+  periodentafel *periode = World::getInstance().getPeriode();
+
+  // build the EditMoleculesMenu
+  Action *createMoleculeAction = new MethodAction("createMoleculeAction",boost::bind(&MoleculeListClass::createNewMolecule,molecules,periode));
+  new ActionMenuItem('c',"create new molecule",editMoleculesMenu,createMoleculeAction);
+
+  Action *loadMoleculeAction = new MethodAction("loadMoleculeAction",boost::bind(&MoleculeListClass::loadFromXYZ,molecules,periode));
+  new ActionMenuItem('l',"load molecule from xyz file",editMoleculesMenu,loadMoleculeAction);
+
+  Action *changeFilenameAction = new MoleculeChangeNameAction(molecules);
+  new ActionMenuItem('n',"change molecule's name",editMoleculesMenu,changeFilenameAction);
+
+  Action *giveFilenameAction = new MethodAction("giveFilenameAction",boost::bind(&MoleculeListClass::setMoleculeFilename,molecules));
+  new ActionMenuItem('N',"give molecules filename",editMoleculesMenu,giveFilenameAction);
+
+  Action *parseAtomsAction = new MethodAction("parseAtomsAction",boost::bind(&MoleculeListClass::parseXYZIntoMolecule,molecules));
+  new ActionMenuItem('p',"parse atoms in xyz file into molecule",editMoleculesMenu,parseAtomsAction);
+
+  Action *eraseMoleculeAction = new MethodAction("eraseMoleculeAction",boost::bind(&MoleculeListClass::eraseMolecule,molecules));
+  new ActionMenuItem('r',"remove a molecule",editMoleculesMenu,eraseMoleculeAction);
+
+}
Index: src/UIElements/TextWindow.hpp
===================================================================
--- src/UIElements/TextWindow.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/UIElements/TextWindow.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -17,17 +17,20 @@
 class TextStatusIndicator;
 
+
 class TextWindow : public MainWindow
 {
 public:
-  TextWindow(menuPopulaters,MoleculeListClass *, config *, periodentafel *, char *);
+  TextWindow();
   virtual ~TextWindow();
 
   virtual void display();
 private:
+  // populaters
+  void populateEditMoleculesMenu(Menu* editMoleculesMenu);
+
   TextMenu *main_menu;
 
   // some actions only needed in textMenus
   Action *quitAction;
-  Action *returnFromEditMoleculeAction;
   // all views that are contained in the main Menu
   StringView *moleculeView;
Index: src/UIElements/UIFactory.cpp
===================================================================
--- src/UIElements/UIFactory.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/UIElements/UIFactory.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -8,10 +8,10 @@
 
 #include <cassert>
+#include "Patterns/Singleton_impl.hpp"
 #include "UIElements/UIFactory.hpp"
 
 // all factories that can be used:
 #include "UIElements/TextUIFactory.hpp"
-
-UIFactory *UIFactory::theFactory = 0;
+#include "UIElements/CommandLineUIFactory.hpp"
 
 UIFactory::UIFactory()
@@ -27,8 +27,10 @@
 
 void UIFactory::makeUserInterface(InterfaceTypes type) {
-  assert(theFactory == 0 && "makeUserInterface should only be called once");
   switch(type) {
     case Text :
-      theFactory = new TextUIFactory();
+      setInstance(new TextUIFactory());
+      break;
+    case CommandLine:
+      setInstance(new CommandLineUIFactory());
       break;
 
@@ -39,14 +41,3 @@
 }
 
-UIFactory* UIFactory::get(){
-  assert(theFactory != 0 && "No UserInterface created prior to factory access");
-  return theFactory;
-}
-
-
-void UIFactory::purgeInstance(){
-  if(theFactory) {
-    delete theFactory;
-    theFactory = 0;
-  }
-}
+CONSTRUCT_SINGLETON(UIFactory)
Index: src/UIElements/UIFactory.hpp
===================================================================
--- src/UIElements/UIFactory.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/UIElements/UIFactory.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -11,20 +11,31 @@
 class MainWindow;
 class Dialog;
+class DialogDescription;
 
-class MoleculeListClass;
-class config;
-class periodentafel;
+#include "Patterns/Singleton.hpp"
 
-struct menuPopulaters;
-
-class UIFactory
+/**
+ * Abstract Factory to create any kind of User interface object needed by the programm.
+ *
+ * The factory can be created and has to be set to a certain type upon creation. It will then
+ * only create UIelements of that certain type, so that all UIElements match. This way different
+ * UIs can be handled in a concise abstract way.
+ */
+class UIFactory : public Singleton<UIFactory,false>
 {
 
 public:
-  enum InterfaceTypes {Text};
+  enum InterfaceTypes {Text, CommandLine};
   virtual ~UIFactory();
 
-  // methods for creating UIElements
-  virtual MainWindow* makeMainWindow(menuPopulaters,MoleculeListClass *, config *, periodentafel *, char *)=0;
+  /**
+   * Produce some kind of main window, of whichever type was chosen when the factory was created
+   */
+  virtual MainWindow* makeMainWindow()=0;
+
+  /**
+   * Produce a User Interaction Dialog, that can query values from the User.
+   * Again the type is determined upon factory creation.
+   */
   virtual Dialog* makeDialog()=0;
 
@@ -32,12 +43,10 @@
   UIFactory();
 
-// singleton stuff
-private:
-  static UIFactory *theFactory;
+public:
+  /**
+   * create a Factory of a certain type. From that moment on only those UIElements can be produced by the factory
+   */
+  static void makeUserInterface(InterfaceTypes type);
 
-public:
-  static void makeUserInterface(InterfaceTypes type);
-  static UIFactory* get();
-  static void purgeInstance();
 };
 
Index: src/Views/MethodStringView.cpp
===================================================================
--- src/Views/MethodStringView.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Views/MethodStringView.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -7,4 +7,6 @@
 
 #include "MethodStringView.hpp"
+
+using namespace std;
 
 MethodStringView::MethodStringView(boost::function<string()> _displayMethod) :
Index: src/Views/MethodStringView.hpp
===================================================================
--- src/Views/MethodStringView.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Views/MethodStringView.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -19,11 +19,11 @@
 {
 public:
-  MethodStringView(boost::function<string()>);
+  MethodStringView(boost::function<std::string()>);
   virtual ~MethodStringView();
 
-  virtual const string toString();
+  virtual const std::string toString();
 
 private:
-  boost::function<string()> displayMethod;
+  boost::function<std::string()> displayMethod;
 };
 
Index: src/Views/StreamStringView.hpp
===================================================================
--- src/Views/StreamStringView.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Views/StreamStringView.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -10,4 +10,5 @@
 
 #include <boost/function.hpp>
+#include <iostream>
 
 #include "Views/StringView.hpp"
@@ -24,11 +25,11 @@
 {
 public:
-  StreamStringView(boost::function<void(ofstream *)>);
+  StreamStringView(boost::function<void(std::ostream *)>);
   virtual ~StreamStringView();
 
-  virtual const string toString();
+  virtual const std::string toString();
 
 private:
-  boost::function<void(ofstream *)> displayMethod;
+  boost::function<void(std::ostream *)> displayMethod;
 };
 
